package restclient;

import javax.json.*;

/**
 * JSON-REST-Client fuer den Dollar-Kurs,
 * {@link "http://fixer.io"}
 * {@link "http://api.fixer.io/latest?symbols=USD,GBP"}
 */
public class DollarKursRestClient
{
   public static void main( String[] args )
   {
      final String url = "http://api.fixer.io/latest?symbols=USD,GBP";
      JsonObject jsonObj = JsonObjectFromUrlUtil.getJsonObjectFromUrl( url );

      System.out.println( "\n\n------------ Ausgabe aller Root-Key/Values:\n" );
      jsonObj.entrySet().forEach( e -> System.out.println( "key=" + e.getKey() + ", val=" + e.getValue() + "\n" ) );

      System.out.println( "\n------------ Ausgabe aller Key/Values zu 'rates':\n" );
      JsonObject rates = jsonObj.getJsonObject( "rates" );
      rates.entrySet().forEach( e -> System.out.println( "key=" + e.getKey() + ", val=" + e.getValue() + "\n" ) );

      System.out.println( "\n------------ Ermittlung einzelner Elemente:\n" );
      String     date    = jsonObj.getString( "date" );
      String     base    = jsonObj.getString( "base" );
      JsonNumber rateUSD = rates.getJsonNumber( "USD" );
      JsonNumber rateGBP = rates.getJsonNumber( "GBP" );
      System.out.printf(
            "Ein %s kostet %.3f USD bzw. %.3f GBP (%s).\n", base, rateUSD.doubleValue(), rateGBP.doubleValue(), date );

      System.out.println( "\n-----------------------------------------------------\n\n" );
   }
}
